/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _BLOCK_H_RPCGEN
#define _BLOCK_H_RPCGEN

#include <rpc/rpc.h>

#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif


enum JsonResponseFormat {
	GB_JSON_NONE = 0,
	GB_JSON_PLAIN = 1,
	GB_JSON_SPACED = 2,
	GB_JSON_PRETTY = 3,
	GB_JSON_DEFAULT = 4,
	GB_JSON_MAX = 4 + 1,
};
typedef enum JsonResponseFormat JsonResponseFormat;

struct blockCreate {
	char ipaddr[255];
	char volume[255];
	char gbid[127];
	char passwd[127];
	u_quad_t size;
	char block_name[255];
	char *block_hosts;
	bool_t auth_mode;
};
typedef struct blockCreate blockCreate;

struct blockModify {
	char volume[255];
	char block_name[255];
	char gbid[127];
	char passwd[127];
	bool_t auth_mode;
};
typedef struct blockModify blockModify;

struct blockCreateCli {
	char volume[255];
	u_quad_t size;
	u_int mpath;
	bool_t auth_mode;
	bool_t prealloc;
	char block_name[255];
	char *block_hosts;
	enum JsonResponseFormat json_resp;
};
typedef struct blockCreateCli blockCreateCli;

struct blockDeleteCli {
	char block_name[255];
	char volume[255];
	bool_t force;
	enum JsonResponseFormat json_resp;
};
typedef struct blockDeleteCli blockDeleteCli;

struct blockDelete {
	char block_name[255];
	char gbid[127];
};
typedef struct blockDelete blockDelete;

struct blockInfoCli {
	char block_name[255];
	char volume[255];
	enum JsonResponseFormat json_resp;
};
typedef struct blockInfoCli blockInfoCli;

struct blockListCli {
	char volume[255];
	u_quad_t offset;
	enum JsonResponseFormat json_resp;
};
typedef struct blockListCli blockListCli;

struct blockModifyCli {
	char block_name[255];
	char volume[255];
	bool_t auth_mode;
	enum JsonResponseFormat json_resp;
};
typedef struct blockModifyCli blockModifyCli;

struct blockResponse {
	int exit;
	char *out;
	u_quad_t offset;
	struct {
		u_int xdata_len;
		char *xdata_val;
	} xdata;
};
typedef struct blockResponse blockResponse;

#define GLUSTER_BLOCK 21215311
#define GLUSTER_BLOCK_VERS 1

#if defined(__STDC__) || defined(__cplusplus)
#define BLOCK_CREATE 1
extern  enum clnt_stat block_create_1(blockCreate *, blockResponse *, CLIENT *);
extern  bool_t block_create_1_svc(blockCreate *, blockResponse *, struct svc_req *);
#define BLOCK_DELETE 2
extern  enum clnt_stat block_delete_1(blockDelete *, blockResponse *, CLIENT *);
extern  bool_t block_delete_1_svc(blockDelete *, blockResponse *, struct svc_req *);
#define BLOCK_MODIFY 3
extern  enum clnt_stat block_modify_1(blockModify *, blockResponse *, CLIENT *);
extern  bool_t block_modify_1_svc(blockModify *, blockResponse *, struct svc_req *);
extern int gluster_block_1_freeresult (SVCXPRT *, xdrproc_t, caddr_t);

#else /* K&R C */
#define BLOCK_CREATE 1
extern  enum clnt_stat block_create_1();
extern  bool_t block_create_1_svc();
#define BLOCK_DELETE 2
extern  enum clnt_stat block_delete_1();
extern  bool_t block_delete_1_svc();
#define BLOCK_MODIFY 3
extern  enum clnt_stat block_modify_1();
extern  bool_t block_modify_1_svc();
extern int gluster_block_1_freeresult ();
#endif /* K&R C */

#define GLUSTER_BLOCK_CLI 212153113
#define GLUSTER_BLOCK_CLI_VERS 1

#if defined(__STDC__) || defined(__cplusplus)
#define BLOCK_CREATE_CLI 1
extern  enum clnt_stat block_create_cli_1(blockCreateCli *, blockResponse *, CLIENT *);
extern  bool_t block_create_cli_1_svc(blockCreateCli *, blockResponse *, struct svc_req *);
#define BLOCK_LIST_CLI 2
extern  enum clnt_stat block_list_cli_1(blockListCli *, blockResponse *, CLIENT *);
extern  bool_t block_list_cli_1_svc(blockListCli *, blockResponse *, struct svc_req *);
#define BLOCK_INFO_CLI 3
extern  enum clnt_stat block_info_cli_1(blockInfoCli *, blockResponse *, CLIENT *);
extern  bool_t block_info_cli_1_svc(blockInfoCli *, blockResponse *, struct svc_req *);
#define BLOCK_DELETE_CLI 4
extern  enum clnt_stat block_delete_cli_1(blockDeleteCli *, blockResponse *, CLIENT *);
extern  bool_t block_delete_cli_1_svc(blockDeleteCli *, blockResponse *, struct svc_req *);
#define BLOCK_MODIFY_CLI 5
extern  enum clnt_stat block_modify_cli_1(blockModifyCli *, blockResponse *, CLIENT *);
extern  bool_t block_modify_cli_1_svc(blockModifyCli *, blockResponse *, struct svc_req *);
extern int gluster_block_cli_1_freeresult (SVCXPRT *, xdrproc_t, caddr_t);

#else /* K&R C */
#define BLOCK_CREATE_CLI 1
extern  enum clnt_stat block_create_cli_1();
extern  bool_t block_create_cli_1_svc();
#define BLOCK_LIST_CLI 2
extern  enum clnt_stat block_list_cli_1();
extern  bool_t block_list_cli_1_svc();
#define BLOCK_INFO_CLI 3
extern  enum clnt_stat block_info_cli_1();
extern  bool_t block_info_cli_1_svc();
#define BLOCK_DELETE_CLI 4
extern  enum clnt_stat block_delete_cli_1();
extern  bool_t block_delete_cli_1_svc();
#define BLOCK_MODIFY_CLI 5
extern  enum clnt_stat block_modify_cli_1();
extern  bool_t block_modify_cli_1_svc();
extern int gluster_block_cli_1_freeresult ();
#endif /* K&R C */

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_JsonResponseFormat (XDR *, JsonResponseFormat*);
extern  bool_t xdr_blockCreate (XDR *, blockCreate*);
extern  bool_t xdr_blockModify (XDR *, blockModify*);
extern  bool_t xdr_blockCreateCli (XDR *, blockCreateCli*);
extern  bool_t xdr_blockDeleteCli (XDR *, blockDeleteCli*);
extern  bool_t xdr_blockDelete (XDR *, blockDelete*);
extern  bool_t xdr_blockInfoCli (XDR *, blockInfoCli*);
extern  bool_t xdr_blockListCli (XDR *, blockListCli*);
extern  bool_t xdr_blockModifyCli (XDR *, blockModifyCli*);
extern  bool_t xdr_blockResponse (XDR *, blockResponse*);

#else /* K&R C */
extern bool_t xdr_JsonResponseFormat ();
extern bool_t xdr_blockCreate ();
extern bool_t xdr_blockModify ();
extern bool_t xdr_blockCreateCli ();
extern bool_t xdr_blockDeleteCli ();
extern bool_t xdr_blockDelete ();
extern bool_t xdr_blockInfoCli ();
extern bool_t xdr_blockListCli ();
extern bool_t xdr_blockModifyCli ();
extern bool_t xdr_blockResponse ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_BLOCK_H_RPCGEN */
